Bullet Collision Detection & Physics Library: btMinkowskiSumShape Class Reference

Bullet Collision Detection & Physics Library

Public Member Functions | Private Attributes | List of all members
btMinkowskiSumShape Class Reference

The btMinkowskiSumShape is only for advanced users. This shape represents implicit based minkowski sum of two convex implicit shapes. More...

`#include <btMinkowskiSumShape.h>`

Inheritance diagram for btMinkowskiSumShape:
[legend]
Collaboration diagram for btMinkowskiSumShape:
[legend]

## Public Member Functions
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btMinkowskiSumShape (const btConvexShape *shapeA, const btConvexShape *shapeB)
virtual btVector3 | localGetSupportingVertexWithoutMargin (const btVector3 &vec) const
virtual void | batchedUnitVectorGetSupportingVertexWithoutMargin (const btVector3 *vectors, btVector3 *supportVerticesOut, int numVectors) const
virtual void | calculateLocalInertia (btScalar mass, btVector3 &inertia) const
void | setTransformA (const btTransform &transA)
void | setTransformB (const btTransform &transB)
const btTransform & | getTransformA () const
const btTransform & | getTransformB () const
const btTransform & | GetTransformB () const
virtual btScalar | getMargin () const
const btConvexShape * | getShapeA () const
const btConvexShape * | getShapeB () const
virtual const char * | getName () const
Public Member Functions inherited from btConvexInternalShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
virtual | ~btConvexInternalShape ()
virtual btVector3 | localGetSupportingVertex (const btVector3 &vec) const
const btVector3 & | getImplicitShapeDimensions () const
void | setImplicitShapeDimensions (const btVector3 &dimensions)
| warning: use setImplicitShapeDimensions with care changing a collision shape while the body is in the world is not recommended, it is best to remove the body from the world, then make the change, and re-add it alternatively flush the contact points, see documentation for 'cleanProxyFromPairs'
void | setSafeMargin (btScalar minDimension, btScalar defaultMarginMultiplier=0.1f)
void | setSafeMargin (const btVector3 &halfExtents, btScalar defaultMarginMultiplier=0.1f)
void | getAabb (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
| getAabb's default implementation is brute force, expected derived classes to implement a fast dedicated version
virtual void | getAabbSlow (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual void | setLocalScaling (const btVector3 &scaling)
virtual const btVector3 & | getLocalScaling () const
const btVector3 & | getLocalScalingNV () const
virtual void | setMargin (btScalar margin)
btScalar | getMarginNV () const
virtual int | getNumPreferredPenetrationDirections () const
virtual void | getPreferredPenetrationDirection (int index, btVector3 &penetrationVector) const
virtual int | calculateSerializeBufferSize () const
virtual const char * | serialize (void *dataBuffer, btSerializer *serializer) const
| fills the dataBuffer and returns the struct name (and 0 on failure)
Public Member Functions inherited from btConvexShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btConvexShape ()
| not supported on IBM SDK, until we fix the alignment of btVector3
virtual | ~btConvexShape ()
btVector3 | localGetSupportVertexWithoutMarginNonVirtual (const btVector3 &vec) const
btVector3 | localGetSupportVertexNonVirtual (const btVector3 &vec) const
btScalar | getMarginNonVirtual () const
void | getAabbNonVirtual (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual void | project (const btTransform &trans, const btVector3 &dir, btScalar &minProj, btScalar &maxProj, btVector3 &witnesPtMin, btVector3 &witnesPtMax) const
Public Member Functions inherited from btCollisionShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btCollisionShape ()
virtual | ~btCollisionShape ()
virtual void | getBoundingSphere (btVector3 &center, btScalar &radius) const
virtual btScalar | getAngularMotionDisc () const
| getAngularMotionDisc returns the maximum radius needed for Conservative Advancement to handle time-of-impact with rotations.
virtual btScalar | getContactBreakingThreshold (btScalar defaultContactThresholdFactor) const
void | calculateTemporalAabb (const btTransform &curTrans, const btVector3 &linvel, const btVector3 &angvel, btScalar timeStep, btVector3 &temporalAabbMin, btVector3 &temporalAabbMax) const
| calculateTemporalAabb calculates the enclosing aabb for the moving object over interval [0..timeStep) result is conservative
bool | isPolyhedral () const
bool | isConvex2d () const
bool | isConvex () const
bool | isNonMoving () const
bool | isConcave () const
bool | isCompound () const
bool | isSoftBody () const
bool | isInfinite () const
| isInfinite is used to catch simulation error (aabb check)
int | getShapeType () const
virtual btVector3 | getAnisotropicRollingFrictionDirection () const
| the getAnisotropicRollingFrictionDirection can be used in combination with setAnisotropicFriction See Bullet/Demos/RollingFrictionDemo for an example
void | setUserPointer (void *userPtr)
| optional user data pointer
void * | getUserPointer () const
void | setUserIndex (int index)
int | getUserIndex () const
void | setUserIndex2 (int index)
int | getUserIndex2 () const
virtual void | serializeSingleShape (btSerializer *serializer) const

## Private Attributes
btTransform | m_transA
btTransform | m_transB
const btConvexShape * | m_shapeA
const btConvexShape * | m_shapeB

## Additional Inherited Members
Protected Member Functions inherited from btConvexInternalShape
| btConvexInternalShape ()
Protected Attributes inherited from btConvexInternalShape
btVector3 | m_localScaling
btVector3 | m_implicitShapeDimensions
btScalar | m_collisionMargin
btScalar | m_padding
Protected Attributes inherited from btCollisionShape
int | m_shapeType
void * | m_userPointer
int | m_userIndex
int | m_userIndex2

## Detailed Description

The btMinkowskiSumShape is only for advanced users. This shape represents implicit based minkowski sum of two convex implicit shapes.

Definition at line 23 of file btMinkowskiSumShape.h.

## Constructor & Destructor Documentation

## ◆ btMinkowskiSumShape()

btMinkowskiSumShape::btMinkowskiSumShape | ( | const btConvexShape * | shapeA,
|  | const btConvexShape * | shapeB )

Definition at line 18 of file btMinkowskiSumShape.cpp.

## Member Function Documentation

## ◆ batchedUnitVectorGetSupportingVertexWithoutMargin()

void btMinkowskiSumShape::batchedUnitVectorGetSupportingVertexWithoutMargin | ( | const btVector3 * | vectors,
|  | btVector3 * | supportVerticesOut,
|  | int | numVectors ) const
| virtual

Implements btConvexShape.

Definition at line 35 of file btMinkowskiSumShape.cpp.

## ◆ BT_DECLARE_ALIGNED_ALLOCATOR()

btMinkowskiSumShape::BT_DECLARE_ALIGNED_ALLOCATOR | ( |  | ) |

## ◆ calculateLocalInertia()

void btMinkowskiSumShape::calculateLocalInertia | ( | btScalar | mass,
|  | btVector3 & | inertia ) const
| virtual

Implements btCollisionShape.

Definition at line 49 of file btMinkowskiSumShape.cpp.

## ◆ getMargin()

btScalar btMinkowskiSumShape::getMargin | ( |  | ) | const
| virtual

Reimplemented from btConvexInternalShape.

Definition at line 44 of file btMinkowskiSumShape.cpp.

## ◆ getName()

virtual const char * btMinkowskiSumShape::getName | ( |  | ) | const
| inlinevirtual

Implements btCollisionShape.

Definition at line 56 of file btMinkowskiSumShape.h.

## ◆ getShapeA()

const btConvexShape * btMinkowskiSumShape::getShapeA | ( |  | ) | const
| inline

Definition at line 53 of file btMinkowskiSumShape.h.

## ◆ getShapeB()

const btConvexShape * btMinkowskiSumShape::getShapeB | ( |  | ) | const
| inline

Definition at line 54 of file btMinkowskiSumShape.h.

## ◆ getTransformA()

const btTransform & btMinkowskiSumShape::getTransformA | ( |  | ) | const
| inline

Definition at line 45 of file btMinkowskiSumShape.h.

## ◆ GetTransformB()

const btTransform & btMinkowskiSumShape::GetTransformB | ( |  | ) | const
| inline

Definition at line 49 of file btMinkowskiSumShape.h.

## ◆ getTransformB()

const btTransform & btMinkowskiSumShape::getTransformB | ( |  | ) | const
| inline

Definition at line 46 of file btMinkowskiSumShape.h.

## ◆ localGetSupportingVertexWithoutMargin()

btVector3 btMinkowskiSumShape::localGetSupportingVertexWithoutMargin | ( | const btVector3 & | vec | ) | const
| virtual

Implements btConvexShape.

Definition at line 28 of file btMinkowskiSumShape.cpp.

## ◆ setTransformA()

void btMinkowskiSumShape::setTransformA | ( | const btTransform & | transA | ) |
| inline

Definition at line 42 of file btMinkowskiSumShape.h.

## ◆ setTransformB()

void btMinkowskiSumShape::setTransformB | ( | const btTransform & | transB | ) |
| inline

Definition at line 43 of file btMinkowskiSumShape.h.

## Member Data Documentation

## ◆ m_shapeA

const btConvexShape* btMinkowskiSumShape::m_shapeA
| private

Definition at line 28 of file btMinkowskiSumShape.h.

## ◆ m_shapeB

const btConvexShape* btMinkowskiSumShape::m_shapeB
| private

Definition at line 29 of file btMinkowskiSumShape.h.

## ◆ m_transA

btTransform btMinkowskiSumShape::m_transA
| private

Definition at line 26 of file btMinkowskiSumShape.h.

## ◆ m_transB

btTransform btMinkowskiSumShape::m_transB
| private

Definition at line 27 of file btMinkowskiSumShape.h.

The documentation for this class was generated from the following files:

- btMinkowskiSumShape.h
- btMinkowskiSumShape.cpp